import java.util.*;
//***********************************************************************************
/** Class to return iterate of Tent map function.<br>
*/
//***********************************************************************************

public class ShiftFunction extends Map1DFunction {
      private static final double Pi=Math.PI;

      ShiftFunction() {
            nParameters=1;
            a=new double[nParameters];
            aDefault = new double [nParameters];
            aDefault[0]=1.7;
            aMinimum=0.;
            aMaximum=2.;
            enforceARange=true;
            x0Default=0.2;
            title = "Shift Map";   
      }
      
      public double evaluateFunction(double x) {                        
            x=a[0]*x;
            if(x>1.)x=x-1.;
            return x;
      }
      
      public double evaluateDerivative(double x) {            
            return a[0];            
      }      
}



